题目地址:https://leetcode.cn/problems/best-time-to-buy-and-sell-stock/
给定一个数组 prices ,它的第 i 个元素 prices[i] 表示一支给定股票第 i 天的价格。
你只能选择 某一天 买入这只股票,并选择在 未来的某一个不同的日子 卖出该股票。设计一个算法来计算你所能获取的最大利润。
返回你可以从这笔交易中获取的最大利润。如果你不能获取任何利润,返回 0 。
示例 1:
输入:[7,1,5,3,6,4]
输出:5
解释:在第 2 天(股票价格 = 1)的时候买入,在第 5 天(股票价格 = 6)的时候卖出,最大利润 = 6-1 = 5 。注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格;同时,你不能在买入前卖出股票。
示例 2:
输入:prices = [7,6,4,3,1]
输出:0
解释:在这种情况下, 没有交易完成, 所以最大利润为 0。
提示:
1 <= prices.length <= 10^5
0 <= prices[i] <= 10^4
方法一:暴力法
需要找出给定数组中两个数字之间的最大差值(即,最大利润)。
此外,第二个数字(卖出价格)必须大于第一个数字(买入价格)。
public class Solution {
public int maxProfit(int[] prices) {
int maxprofit = 0;
for (int i = 0; i < prices.length - 1; i++) {
for (int j = i + 1; j < prices.length; j++) {
int profit = prices[j] - prices[i];
if (profit > maxprofit) {
maxprofit = profit;
}
}
}
return maxprofit;
}
}
复杂度分析:
时间复杂度:O(n^2)
空间复杂度:O(1)
方法二 动态规划
假如计划在第 i 天卖出股票,那么最大利润的差值一定是在[0, i-1] 之间选最低点买入;所以遍历数组,依次求每个卖出时机的的最大差值,再从中取最大值。
dp[i]表示截止到i,价格的最低点是多少。
考虑每次如何获取最大收益?第 i 天的最大收益等于第 i 天的价格减 [0, i-1] 天的最低价格。而最低价格取决于第 i 天和前 i-1天谁更低,至此我们的转移方程就出来了。
dp[i] = min(d[i-1], prices[i])
其中 dp[0]=prices[0],然后动态计算之后的就可以了。 得到了前i天的最低点以后,只需要维护一个max用来保存最大收益就可以了。
这个时候是空间复杂度O(n)的动态规划,代码如下
//dp[i]表示截止到i,价格的最低点是多少 dp[i]=min(dp[i-1],nums[i])
int max = 0;
int[] dp = new int[prices.length];
dp[0] = prices[0];
for (int i = 1; i < prices.length; i++) {
dp[i] = (dp[i - 1] < prices[i]) ? dp[i - 1] : prices[i];
max = (prices[i] - dp[i]) > max ? prices[i] - dp[i] : max;
}
return max;
接着考虑优化空间
仔细观察动态规划的辅助数组,其每一次只用到了 dp[i-1] 这一个空间,因此可以把数组改成单个变量 minPrice 来存储截止到第 i 天的价格最低点,得到最终解法:
public class Solution {
public int maxProfit(int prices[]) {
int minPrice = Integer.MAX_VALUE, maxProfit = 0;
for (int i = 0; i < prices.length; i++) {
if (prices[i] < minPrice) {
minPrice = prices[i];
}
else if (i > 0) {
int profit = prices[i] - minPrice;
if (profit > maxProfit) {
maxProfit = profit;
}
}
}
return maxProfit;
}
}
复杂度分析:
时间复杂度:O(n)
空间复杂度:O(1)
本文完,希望对你有帮助。